/* Generated by powerful Codeforces Tool
 * Author: xxxodarap
 * Time: 2023-08-20 16:10
**/

#include<bits/stdc++.h>
using namespace std;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;


template<class T> bool ckmin(T& a, const T& b) { return b < a ? a = b, 1 : 0; }
template<class T> bool ckmax(T& a, const T& b) { return a < b ? a = b, 1 : 0; }


const lf PI = acos(-1), EPSI = 1e-9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


// =============== Solution section ===============
const int MAXN = 2e5 + 5;
ll N, K;
vector<int> inedges[MAXN];


// copied from reference
vector<int> edges[MAXN], topsort, ideg(MAXN);
void kahn(int n){
  queue<int> q;
  for (int i = 1; i <= n; i++)
    if (!ideg[i])
      q.push(i);
  while(!empty(q)){
    int u = q.front(); q.pop();
    for (int v: edges[u])
      if (--ideg[v] == 0)
        q.push(v);
    topsort.push_back(u);
  }
}



void solve(){
    // Code goes here ...
    cin >> N >> K;
    fill(edges, edges + N + 2, vector<int>());
    fill(inedges, inedges + N + 2, vector<int>());
    topsort.clear();
    ideg = vector<int>(N + 2);

    vector<ll> costs(N + 4);
    F(i, 1, N + 1)
        cin >> costs[i];

    int id;
    R(i, K){
        cin >> id;
        costs[id] = 0;
    }

    int num, inid;
    F(out, 1, N + 1){
        cin >> num;
        ideg[out] = num;
        R(j,  num){
            cin >> inid;
            edges[inid].push_back(out);
            inedges[out].push_back(inid);
        }
    }

    // topological sorting with kahn
    kahn(N);

    ll brewcost;
    for(int node: topsort){
        if(inedges[node].empty()) continue;
        brewcost = 0;
        for(int innode: inedges[node])
            brewcost += costs[innode];
        costs[node] = min(costs[node], brewcost);
    }

    /* ll res = accumulate(costs, costs+N,0); */
    F(i, 1, N+1)
        cout << costs[i] << " ";
    cout << endl;
}




// =============== Main section ===============
int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << setprecision(12); // << fixed;

    int T = 1;
    cin >> T;
    while(T--)
        solve();

    return 0;
}
        
